<!--
    Copyright (c) 2020, 2021 Texas Instruments Incorporated
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

    *   Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
    *   Neither the name of Texas Instruments Incorporated nor the names of
    its contributors may be used to endorse or promote products derived
    from this software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
    THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
    OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
    OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
    EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>gc-widget-menubar Demo</title>
	<script nomodule="" src="../../build/gc-components.js"></script>
    <script type="module" src="../../build/gc-components.esm.js"></script>
    <script type="module" src="../../gc-core-databind/lib/CoreDatabind"></script>
    <link rel="stylesheet" type="text/css" href="../../../assets/stylesheets/gc-demo-stylesheet.css">

    <style>
        #viewport {
            width: 100%;
            height: 100%;
            min-height: 200px;
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
        }

        #output {
            margin-top: 30px;
            padding: 20px;
        }
    </style>
</head>

<body>
    <div id="demo_container">
        <gc-widget-menubar id="demo_element_menubar" product-name="MenuBar" product-icon="hardware:memory" open-on-hover layout horizontal>
            <gc-widget-menuitem id="demo_element_menuitem" label="File" layout vertical>
                <gc-widget-menuitem label="New" icon="action:list">
                    <gc-widget-menuitem label="Documents" icon="file:text_snippet">
                        <gc-widget-menuaction label="JavaScript"></gc-widget-menuaction>
                        <gc-widget-menuaction label="JSON"></gc-widget-menuaction>
                        <gc-widget-menuaction label="CSS"></gc-widget-menuaction>
                    </gc-widget-menuitem>
                    <gc-widget-menuaction label="New Window"></gc-widget-menuaction>
                    <gc-widget-menuaction label="New Terminal"></gc-widget-menuaction>
                </gc-widget-menuitem>
                <gc-widget-menuseparator></gc-widget-menuseparator>
                <gc-widget-menuitem label="Font Size" icon="content:text_format" layout vertical>
                    <gc-widget-menuaction action-id="cmd_font_small" label="Small" toggle></gc-widget-menuaction>
                    <gc-widget-menuaction action-id="cmd_font_medium" label="Medium" toggle></gc-widget-menuaction>
                    <gc-widget-menuaction action-id="cmd_font_large" label="Large" toggle></gc-widget-menuaction>
                    <gc-widget-menuaction action-id="cmd_font_xlarge" label="x-Large" toggle></gc-widget-menuaction>
                </gc-widget-menuitem>
                <gc-widget-menuseparator></gc-widget-menuseparator>
                <gc-widget-menuaction id="demo_element_print" action-id="cmd_print" label="Print" icon="action:print"></gc-widget-menuaction>
                <gc-widget-menuseparator></gc-widget-menuseparator>
                <gc-widget-menuaction id="demo_element_not_visible" action-id="cmd_not_visible" label="I am not supposed to be visible!"></gc-widget-menuaction>
                <gc-widget-menuaction id="demo_element_menuaction" action-id="cmd_exit" label="Exit" icon="action:exit_to_app" hotkey="Ctrl+x"></gc-widget-menuaction>
            </gc-widget-menuitem>

            <gc-widget-menuitem label="Edit" layout vertical>
                <gc-widget-menuaction action-id="cmd_copy" label="Copy" icon="content:content_copy"></gc-widget-menuaction>
                <gc-widget-menuaction action-id="cmd_paste" label="Paste" icon="content:content_paste"></gc-widget-menuaction>
                <gc-widget-menuaction action-id="cmd_cut" label="Cut" icon="content:content_cut"></gc-widget-menuaction>
            </gc-widget-menuitem>
            <div style="width: 50px;"></div>
            <gc-widget-menuitem id="demo_element_settings" slot="tool-list" icon="action:settings" layout vertical>
                <gc-widget-menuitem id="demo_element_editor" label="Editor" icon="editor:short_text">
                    <gc-widget-menuaction id="demo_element_auto_save" action-id="cmd_auto_save" label="Auto Save" icon="content:save" toggle></gc-widget-menuaction>
                    <gc-widget-menuaction action-id="cmd_show_white_space" label="Show White Spaces" icon="editor:space_bar" toggle></gc-widget-menuaction>
                </gc-widget-menuitem>
            </gc-widget-menuitem>
        </gc-widget-menubar>
        <div id="viewport">
            <div>This is the view port.</div>
            <div id="output" class="highlight">Select menu action to see output here.</div>
        </div>
    </div>
    <div id="demo_properties_container">
        <table>
            <tr>
                <th><gc-widget-label label="MenuBar Property"></gc-widget-label></th>
                <th><gc-widget-label label="Value"></gc-widget-label></th>
            </tr>
            <tr>
                <td><gc-widget-label label="openOnHover"></gc-widget-label></td>
                <td><gc-widget-checkbox id="open_on_hover" checked></gc-widget-checkbox></td>
            </tr>
            <tr>
                <td><gc-widget-label label="productName"></gc-widget-label></td>
                <td><gc-widget-input id="product_name" value="MenuBar"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="productIcon"></gc-widget-label></td>
                <td><gc-widget-input id="product_icon" value="hardware:memory"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="produceIconFolderPath"></gc-widget-label></td>
                <td><gc-widget-input id="product_icon_folder_path"></td>
            </tr>
            <tr>
                <th><gc-widget-label label="MenuItem Property"></gc-widget-label></th>
                <th><gc-widget-label label="Value"></gc-widget-label></th>
            </tr>
            <tr>
                <td><gc-widget-label label="label"></gc-widget-label></td>
                <td><gc-widget-input id="menuitem_label" value="File"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="icon"></gc-widget-label></td>
                <td><gc-widget-input id="menuitem_icon"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="iconFolderPath"></gc-widget-label></td>
                <td><gc-widget-input id="menuitem_icon_folder_path"></td>
            </tr>
            <tr>
                <th><gc-widget-label label="MenuAction Property"></gc-widget-label></th>
                <th><gc-widget-label label="Value"></gc-widget-label></th>
            </tr>
            <tr>
                <td><gc-widget-label label="label"></gc-widget-label></td>
                <td><gc-widget-input id="menuaction_label" value="Exit"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="icon"></gc-widget-label></td>
                <td><gc-widget-input id="menuaction_icon" value="action:exit_to_app"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="iconFolderPath"></gc-widget-label></td>
                <td><gc-widget-input id="menuaction_icon_folder_path"></td>
            </tr>
            <tr>
                <td><gc-widget-label label="hotkey"></gc-widget-label></td>
                <td><gc-widget-input disabled value="Ctrl+X"></gc-widget-input></td>
            </tr>
            <tr>
                <td><gc-widget-label label="toggle"></gc-widget-label></td>
                <td><gc-widget-checkbox disabled label="(readonly)"></gc-widget-checkbox></td>
            </tr>
            <tr>
                <td><gc-widget-label label="actionId"></gc-widget-label></td>
                <td><gc-widget-input disabled value="cmd_exit"></gc-widget-input></td>
            </tr>
        </table>
    </div>
</body>

<script type="module">
    import { ActionRegistry } from '../lib/ActionRegistry';

    const output = document.querySelector('#output');
    const ACTION = {
        run: detail => output.innerHTML = `Command "${detail.id}" executed`,
        isEnabled: () => true,
    };

    let autoSave = true;
    ActionRegistry.registerAction('cmd_auto_save', Object.assign({}, ACTION, {
        run: detail => {
            autoSave = !autoSave;
            output.innerHTML = `Auto Save enabled = ${ autoSave }`;
        },
        isChecked: () => { return autoSave }
    }));

    ActionRegistry.registerAction('cmd_exit', Object.assign({}, ACTION));
    ActionRegistry.registerAction('cmd_print', Object.assign({}, ACTION, { isEnabled: () => false }));
    ActionRegistry.registerAction('cmd_copy', Object.assign({}, ACTION));
    ActionRegistry.registerAction('cmd_cut', Object.assign({}, ACTION));
    ActionRegistry.registerAction('cmd_paste', Object.assign({}, ACTION));
    ActionRegistry.registerAction('cmd_not_visible', Object.assign({}, ACTION, { isVisible: () => false }));

    let currentFont = 'cmd_font_small';
    ActionRegistry.registerActionGroup(['cmd_font_small', 'cmd_font_medium', 'cmd_font_large', 'cmd_font_xlarge'], {
        run: detail => {
            currentFont = detail.id;
            output.innerHTML = `Command "${detail.id}" executed`;
        },
        isChecked: id => id === currentFont,
        isEnabled: id => id !== 'cmd_font_medium',
        isVisible: id => id !== 'cmd_font_xlarge'
    });

    (async () => {
        const menubar = document.querySelector('gc-widget-menubar');
        menubar.addEventListener('product-name-clicked', () => output.innerHTML = 'Product name clicked!');
    })();
</script>
</html>